unit Defstr;

interface
type
piecep = array[0..3,0..3] of byte;
type piece=record
    nrpos:byte;
    pp:array[1..4] of piecep;
    leading0:array[1..4] of byte;
    x,y:byte;
    xg,yg:byte; { goal }
    actpos:byte;
    size:byte; { nr of squares }
    color:longint;
  end;
type restype=record
  xp:array[0..9] of byte;
  xpos:array[0..9] of byte;
end;
type matr=array[0..9,0..9] of byte;
const
t1:piecep=((1,1,1,0),
          (0,1,0,0),
          (0,1,0,0),
          (0,1,0,0));
const
t2:piecep=((1,0,0,0),
          (1,1,1,1),
          (1,0,0,0),
          (0,0,0,0));
t3:piecep=((0,1,0,0),
          (0,1,0,0),
          (0,1,0,0),
          (1,1,1,0));
t4:piecep=((0,0,0,1),
          (1,1,1,1),
          (0,0,0,1),
          (0,0,0,0));
z1:piecep=((1,0,0,0),
           (1,1,1,0),
           (0,0,1,0),
           (0,0,0,0));
z2:piecep=((0,1,1,0),
           (0,1,0,0),
           (1,1,0,0),
           (0,0,0,0));
p1:piecep=((1,1,0,0),
           (1,1,1,0),
           (0,0,0,0),
           (0,0,0,0));
p2:piecep=((0,1,0,0),
           (1,1,0,0),
           (1,1,0,0),
           (0,0,0,0));
p3:piecep=((1,1,1,0),
           (0,1,1,0),
           (0,0,0,0),
           (0,0,0,0));
p4:piecep=((1,1,0,0),
           (1,1,0,0),
           (1,0,0,0),
           (0,0,0,0));
o1:piecep=((1,1,0,0),
           (1,1,0,0),
           (0,0,0,0),
           (0,0,0,0));
l1:piecep=((1,0,0,0),
           (1,0,0,0),
           (1,1,0,0),
           (0,0,0,0));
l2:piecep=((0,0,1,0),
           (1,1,1,0),
           (0,0,0,0),
           (0,0,0,0));
l3:piecep=((1,1,0,0),
           (0,1,0,0),
           (0,1,0,0),
           (0,0,0,0));
l4:piecep=((1,1,1,0),
           (1,0,0,0),
           (0,0,0,0),
           (0,0,0,0));
y1:piecep=((1,1,0,0),
           (0,1,0,0),
           (0,1,1,0),
           (0,0,1,0));
y2:piecep=((0,0,1,1),
           (1,1,1,0),
           (1,0,0,0),
           (0,0,0,0));
y3:piecep=((1,0,0,0),
           (1,1,0,0),
           (0,1,0,0),
           (0,1,1,0));
y4:piecep=((0,0,0,1),
           (0,1,1,1),
           (1,1,0,0),
           (0,0,0,0));
w1:piecep=((1,1,0,0),
           (0,1,1,0),
           (0,0,1,0),
           (0,0,0,0));
w2:piecep=((0,1,1,0),
           (1,1,0,0),
           (1,0,0,0),
           (0,0,0,0));
w3:piecep=((1,0,0,0),
           (1,1,0,0),
           (0,1,1,0),
           (0,0,0,0));
w4:piecep=((0,0,1,0),
           (0,1,1,0),
           (1,1,0,0),
           (0,0,0,0));
n1:piecep=((1,1,1,1),
           (0,0,0,1),
           (0,0,0,1),
           (0,0,0,0));
n2:piecep=((1,1,1,0),
           (1,0,0,0),
           (1,0,0,0),
           (1,0,0,0));
n3:piecep=((1,0,0,0),
           (1,0,0,0),
           (1,1,1,1),
           (0,0,0,0));
n4:piecep=((0,0,1,0),
           (0,0,1,0),
           (0,0,1,0),
           (1,1,1,0));
i1:piecep=((1,1,1,0),
           (0,0,0,0),
           (0,0,0,0),
           (0,0,0,0));
i2:piecep=((1,0,0,0),
           (1,0,0,0),
           (1,0,0,0),
           (0,0,0,0));
v1:piecep=((1,1,1,0),
           (1,0,0,0),
           (1,0,0,0),
           (0,0,0,0));
v2:piecep=((1,0,0,0),
           (1,0,0,0),
           (1,1,1,0),
           (0,0,0,0));
v3:piecep=((0,0,1,0),
           (0,0,1,0),
           (1,1,1,0),
           (0,0,0,0));
v4:piecep=((1,1,1,0),
           (0,0,1,0),
           (0,0,1,0),
           (0,0,0,0));
var
          tp : array[1..4] of piecep;
          mp:array[0..9] of piece;
          xf,yf:byte;
          mmatr,tmatr:matr;
          res:array[0..9] of byte;
          xxxf,yyyf,xxf,yyf,curri:byte;  { current piece,position }
          xmatr:array[-1..10] of matr;
          xs:array[-1..10] of byte;
          clmatr,cmatr: array [0..6,0..6] of longint;
          aaa:array[0..200] of byte;
          reslist: array[0..100] of restype;
          endfla:boolean;
implementation

end.
